/**
 * \file    Mimic_Float.cpp
 * \author  Silvan Murer
 * \date    13 October 2022
 *
 * \brief   Float class of genSDK GF implementation, based on Mimic_Node
 */

#include "features/Mimic_Float.hpp"
#include "Mimic_Exception.hpp"

#define GENICAM_NO_AUTO_IMPLIB
#include "GenICam.h"

#include <memory>
#include <string>

using namespace GenApi;

namespace mimic {

    Mimic_Float::Mimic_Float() : Mimic_Node() { type = Type_e::FLOAT; };
    Mimic_Float::Mimic_Float(GenApi_3_4::INode* node) : Mimic_Node(node) { type = Type_e::FLOAT; };
    Mimic_Float::~Mimic_Float() { };

    std::variant<int64_t, double, bool, std::string> Mimic_Float::getVariant(std::string name)
    {
        return getValue();
    };
    void Mimic_Float::setVariant(std::string name, std::variant<int64_t, double, bool, std::string> value)
    {
        try {
            setValue(std::get<double>(value));
        }
        catch (std::bad_variant_access const& e) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is of type Float! " + e.what(), -650);
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }

    }

    double Mimic_Float::getValue()
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsReadable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not readable!", -600);
        }
        try {
            return dynamic_cast<IFloat*>(node)->GetValue();
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " read failed!", -610);
        }
    }
    void Mimic_Float::setValue(double value)
    {
        if (!IsImplemented(node) || !IsAvailable(node) || !IsWritable(node)) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " is not writable!", -600);
        }
        try {
            return dynamic_cast<IFloat*>(node)->SetValue(value);
        }
        catch (...) {
            throw Mimic_Access_Exception(std::string("Node ") + node->GetName().c_str() + " write failed!", -610);
        }
    }

} /* namespace genSDK */
